<?php

namespace App\Presenters;

use App\Model\Blog;
use App\Model\Blogcomment;
use App\Model\Comment;
use App\Model\Orm;
use App\Model\User;
use Nette\Application\UI\Form;
use Tracy\Debugger;

class BlogPresenter extends BasePresenter
{

    public Blog $blog;
    public User $databaseUser;

    public function startup()
    {
        parent::startup(); // TODO: Change the autogenerated stub
        if ($this->getUser()->isLoggedIn()) {
            $this->databaseUser=$this->orm->users->getBy(['loginName'=>$this->user->id]);
        }
    }

    public function createComponentBlogForm(): Form
    {
        $form = new Form();

        $form->addText('title', 'Nadpis:')
            ->setRequired('Toto pole je nutné vyplnit');

        $form->addTextArea('content', 'Obsah:')
            ->setRequired('Toto pole je nutné vyplnit');

        $form->addText('image', 'Obrázek:')
            ->setRequired('Toto pole je nutné vyplnit');

        $form->addSubmit('send', 'Přidat příspěvek');
        $form->onSuccess[]=[$this,'blogFormSucces'];

        return $form;
    }

    public function blogFormSucces(Form $form): void
    {
        $values=$form->getValues();
        $blog = new Blog();
        $blog->title=$values->title;
        $blog->content=$values->content;
        $blog->image=$values->image;
        $blog->author=$this->databaseUser;
        $this->orm->persistAndFlush($blog);
        $this->flashMessage('Příspěvek byl přidán.');
        $this->redirect('Blog:default');
    }

    public function actionDefault()
    {
        $posts = $this->orm->blog->findAll();
        $this->template->posts=$posts;
    }

    public function actionDetail($id)
    {
        $blog = $this->orm->blog->getById($id);
        $this->blog = $blog;
        $this->template->blog = $blog;

        $comment = $this->orm->blogcomment->findBy(['this->blog->id'=>$id]);
        $this->template->comment = $comment;
    }

    public function createComponentBlogCommentForm(): Form
    {

        $form = new Form;

        $form->addTextArea('content', 'Komentář:')
            ->setRequired('Toto pole je povinné')
            ->addRule(Form::MAX_LENGTH,'Maximální délka komentáře je 255 znaků',255);

        $form->addText('author', 'Autor:')
            ->setRequired('Toto pole je povinné');

        $form->addText('email');


        $form->addSubmit('send', 'Přidat komentář:');

        $form->onSuccess[]=[$this,'blogCommentFormSucces'];
        return $form;
    }

    public function blogCommentFormSucces (Form $form): void
    {


        $values = $form->getValues();
        $blogcomment = new Blogcomment();
        $blogcomment->content=$values->content;
        $blogcomment->author=$values->author;
        $blogcomment->email=$values->email;
        $blogcomment->blog=$this->blog;
        //TODO zjistit proč nefunguje přidávání komentářů

        $this->orm->persistAndFlush($blogcomment);
        $this->flashMessage('Komentář byl přidán.');
        Debugger::barDump($values);
        $this->redirect('Blog:default');
    }

}